Bug 1312963 - Review Request: glibc-arm-linux-gnu - Cross Compiled GNU C Library targeted at arm-linux-gnu
Review Request: glibc-arm-linux-gnu - Cross Compiled GNU C Library targeted a...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Dominik 'Rathann' Mierzejewski
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1270405
  Show dependency treegraph
 
Reported: 2016-02-29 11:07 EST by Tom "spot" Callaway
Modified: 2016-07-11 22:23 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-06-18 00:24:17 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
dominik: fedora‑review+


Attachments (Terms of Use)
Build log of failed build on rawhide (9.55 MB, text/plain)
2016-03-16 15:29 EDT, Jonathan Underwood
no flags Details
patch to fix compilation with gcc-6.1.1 (1.35 KB, patch)
2016-05-19 12:46 EDT, Dominik 'Rathann' Mierzejewski
no flags Details | Diff

  None (edit)
Description Tom "spot" Callaway 2016-02-29 11:07:16 EST
Spec URL: https://spot.fedorapeople.org/glibc-arm-linux-gnu.spec
SRPM URL: https://spot.fedorapeople.org/glibc-arm-linux-gnu-2.23-1.fc24.src.rpm
Description: 
This is a Cross Compiled version of the GNU C Library, which can be used to
compile and link binaries for the arm-linux-gnu platform, instead of for the
native platform.

Fedora Account System Username: spot

A few notes: As this is a cross-compiled version of glibc, it will not run on the target system (unless your target system is ARM, and then why are you installing a cross-compiler for ARM?). This is why the package is noarch, and why rpmlint throws warnings (they can be ignored). We could make the package arch specific, but the bits _should_ be identical regardless of architecture of the host system.
Comment 1 Jonathan Underwood 2016-03-16 15:27:11 EDT
Unfortunately, while starting a review, I found this doesn't build on rawhide:

+ /usr/lib/rpm/find-lang.sh /builddir/build/BUILDROOT/glibc-arm-linux-gnu-2.23-1.fc25.x86_64 libc
No translations found for libc in /builddir/build/BUILDROOT/glibc-arm-linux-gnu-2.23-1.fc25.x86_64
error: Bad exit status from /var/tmp/rpm-tmp.orb7iQ (%install)
RPM build errors:
    Bad exit status from /var/tmp/rpm-tmp.orb7iQ (%install)
Child return code was: 1


Probably fallout from the glibc langpack re-jigging.

If you can fix that, I'll pick up the review next week - am about to hit the road for a few days. I'll leave the bug untaken for now, in case you fixi it and someone else is just aching to review it.
Comment 2 Jonathan Underwood 2016-03-16 15:29 EDT
Created attachment 1137141 [details]
Build log of failed build on rawhide
Comment 3 Zbigniew Jędrzejewski-Szmek 2016-03-16 20:49:36 EDT
I tried in F23 buildroot and the result is the same. So this is not related to the glibc langpacks thing. I don't see any translations files in the buildroot at all.
Comment 4 Tom "spot" Callaway 2016-04-26 15:54:21 EDT
Fixed this by cleaning up the %files entry. I suspect that this is due to glibc generating these files when other components are present in the Build environment, however, since we don't care about info/locale files, I've just dropped them from the %files list.

Rawhide Scratch Build: http://koji.fedoraproject.org/koji/taskinfo?taskID=13813983
New SRPM: https://spot.fedorapeople.org/glibc-arm-linux-gnu-2.23-2.fc24.src.rpm
New SPEC: https://spot.fedorapeople.org/glibc-arm-linux-gnu.spec
Comment 5 Dominik 'Rathann' Mierzejewski 2016-05-19 12:35:08 EDT
I'll pick up the review. It doesn't build in rawhide:
[...]
arm-linux-gnu-gcc setenv.c -c -std=gnu11 -fgnu89-inline  -O2 -Wall -Werror -Wundef -Wwrite-strings -fmerge-all-constants -frounding-math -g 
-Wstrict-prototypes -Wold-style-definition     -ftls-model=initial-exec      -I../include -I/builddir/build/BUILD/glibc-arm-linux-gnu-2.23/b
uild-arm-linux-gnu-glibc/stdlib  -I/builddir/build/BUILD/glibc-arm-linux-gnu-2.23/build-arm-linux-gnu-glibc  -I../sysdeps/unix/sysv/linux/ar
m  -I../sysdeps/arm/nptl  -I../sysdeps/unix/sysv/linux/include -I../sysdeps/unix/sysv/linux  -I../sysdeps/nptl  -I../sysdeps/pthread  -I../s
ysdeps/gnu  -I../sysdeps/unix/inet  -I../sysdeps/unix/sysv  -I../sysdeps/unix/arm  -I../sysdeps/unix  -I../sysdeps/posix  -I../sysdeps/arm/a
rmv7/multiarch  -I../sysdeps/arm/armv7  -I../sysdeps/arm/armv6t2  -I../sysdeps/arm/armv6  -I../sysdeps/arm/include -I../sysdeps/arm  -I../sy
sdeps/wordsize-32  -I../sysdeps/ieee754/flt-32  -I../sysdeps/ieee754/dbl-64  -I../sysdeps/ieee754  -I../sysdeps/generic  -I.. -I../libio -I.
 -nostdinc -isystem /usr/lib/gcc/arm-linux-gnueabi/6.1.1/include -isystem /usr/lib/gcc/arm-linux-gnueabi/6.1.1/include-fixed -isystem /usr/a
rm-linux-gnu/include  -D_LIBC_REENTRANT -include /builddir/build/BUILD/glibc-arm-linux-gnu-2.23/build-arm-linux-gnu-glibc/libc-modules.h -DM
ODULE_NAME=libc -include ../include/libc-symbols.h       -o /builddir/build/BUILD/glibc-arm-linux-gnu-2.23/build-arm-linux-gnu-glibc/stdlib/
setenv.o -MD -MP -MF /builddir/build/BUILD/glibc-arm-linux-gnu-2.23/build-arm-linux-gnu-glibc/stdlib/setenv.o.dt -MT /builddir/build/BUILD/g
libc-arm-linux-gnu-2.23/build-arm-linux-gnu-glibc/stdlib/setenv.o
setenv.c: In function '__unsetenv':
setenv.c:279:6: error: suggest explicit braces to avoid ambiguous 'else' [-Werror=parentheses]
   if (ep != NULL)
      ^
cc1: all warnings being treated as errors
../o-iterator.mk:9: recipe for target '/builddir/build/BUILD/glibc-arm-linux-gnu-2.23/build-arm-linux-gnu-glibc/stdlib/setenv.o' failed
make[2]: *** [/builddir/build/BUILD/glibc-arm-linux-gnu-2.23/build-arm-linux-gnu-glibc/stdlib/setenv.o] Error 1
make[2]: *** Waiting for unfinished jobs....
make[2]: Leaving directory '/builddir/build/BUILD/glibc-arm-linux-gnu-2.23/glibc-2.23/stdlib'
Makefile:214: recipe for target 'stdlib/subdir_lib' failed
make[1]: *** [stdlib/subdir_lib] Error 2
make[1]: Leaving directory '/builddir/build/BUILD/glibc-arm-linux-gnu-2.23/glibc-2.23'
Makefile:9: recipe for target 'all' failed
make: *** [all] Error 2
Comment 6 Dominik 'Rathann' Mierzejewski 2016-05-19 12:46 EDT
Created attachment 1159546 [details]
patch to fix compilation with gcc-6.1.1

It builds with this patch.
Comment 8 Dominik 'Rathann' Mierzejewski 2016-05-20 07:43:13 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file COPYING is not marked as %license
  See:
  http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Text

  I think this is due to:
  %doc glibc-%{version}/BUGS glibc-%{version}/C* glibc-%{version}/README

  I suggest using:
  %doc glibc-%{version}/BUGS glibc-%{version}/CONFORMANCE
  %doc glibc-%{version}/ChangeLog* glibc-%{version}/README
  %license glibc-%{version}/COPYING*

- Large documentation must go in a -doc subpackage. Large could be size
  (~1MB) or number of files.
  Note: Documentation size is 9533440 bytes in 38 files.
  See:
  http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation

  That's 9M out of ~60M of installed size. I'm not sure including all the
  ChangeLogs is worth the space. I'd gzip them at least.

- Licensecheck found more licenses inside. Please adjust the License: tag or
  explain why it's not required.

- /usr/arm-linux-gnu seems to be unowned

- Why are you using make -j1 in %install?

- Requires: kernel-cross-headers are only for F24+, are they not required on
  F23?

- It's not documented how arm-kernel-headers-4.3.5-300.tar.xz is created

===== MUST items =====

C/C++:
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause) ISC LGPL (v2.1 or later)", "LGPL (v2 or
     later)", "GPL (v2 or later)", "GPL (v3 or later)", "Unknown or
     generated", "MIT/X11 (BSD like)", "BSD", "BSD (3 clause) ISC", "*No
     copyright* LGPL (v2.1 or later)", "LGPL (v2.1 or later) (with
     incorrect FSF address)", "*No copyright* Public domain", "BSD (3
     clause)", "LGPL", "ISC", "LGPL (v2.1 or later)", "GPL (v3)", "GPL
     (v2)", "BSD (3 clause) LGPL (v2.1 or later)". 4729 files have unknown
     license.
[x]: License file installed when any subpackage combination is installed.
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/arm-linux-gnu
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/arm-linux-gnu
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[!]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:

Requires
--------
glibc-arm-linux-gnu-devel (rpmlib, GLIBC filtered):
    glibc-arm-linux-gnu
    kernel-cross-headers

glibc-arm-linux-gnu (rpmlib, GLIBC filtered):


Provides
--------
glibc-arm-linux-gnu-devel:
    glibc-arm-linux-gnu-devel

glibc-arm-linux-gnu:
    glibc-arm-linux-gnu


Source checksums
----------------
ftp://ftp.gnu.org/gnu/glibc/glibc-2.23.tar.xz :
  CHECKSUM(SHA256) this package     : 94efeb00e4603c8546209cefb3e1a50a5315c86fa9b078b6fad758e187ce13e9
  CHECKSUM(SHA256) upstream package : 94efeb00e4603c8546209cefb3e1a50a5315c86fa9b078b6fad758e187ce13e9


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review --rpm-spec -n /home/rathann/build/RPMS/glibc-arm-linux-gnu-2.23-3.fc23.src.rpm -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 9 Dominik 'Rathann' Mierzejewski 2016-06-02 16:36:29 EDT
Ping?
Comment 10 Tom "spot" Callaway 2016-06-06 14:34:14 EDT
Sorry. Mixture of being busy and being sick.

New SRPM: https://spot.fedorapeople.org/glibc-arm-linux-gnu-2.23-4.fc24.src.rpm
New SPEC: https://spot.fedorapeople.org/glibc-arm-linux-gnu.spec

Headers are only needed on Fedora 23 or older, I asked the kernel package to grow the cross-headers package so we wouldn't need to bundle in the future. 

Updated licensing, dropped giant changelogs (not needed), used smp_mflags consistently (even if it might be pointless on an make install), owned target dir.
Comment 11 Dominik 'Rathann' Mierzejewski 2016-06-10 11:22:22 EDT
Great! Everything looks fine now, package APPROVED.
Comment 12 Kevin Fenzi 2016-06-11 14:38:23 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/glibc-arm-linux-gnu
Comment 13 Fedora Update System 2016-06-11 16:26:43 EDT
glibc-arm-linux-gnu-2.23-4.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-91e8c1cf59
Comment 14 Fedora Update System 2016-06-11 16:26:52 EDT
glibc-arm-linux-gnu-2.23-4.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2016-19fabfc432
Comment 15 Fedora Update System 2016-06-11 16:26:57 EDT
glibc-arm-linux-gnu-2.23-4.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-0e39325534
Comment 16 Fedora Update System 2016-06-12 13:51:57 EDT
glibc-arm-linux-gnu-2.23-4.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-0e39325534
Comment 17 Fedora Update System 2016-06-12 19:51:52 EDT
glibc-arm-linux-gnu-2.23-4.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-91e8c1cf59
Comment 18 Fedora Update System 2016-06-12 19:55:04 EDT
glibc-arm-linux-gnu-2.23-4.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-19fabfc432
Comment 19 Fedora Update System 2016-06-18 00:24:14 EDT
glibc-arm-linux-gnu-2.23-4.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 20 Fedora Update System 2016-06-18 14:33:33 EDT
glibc-arm-linux-gnu-2.23-4.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.
Comment 21 Fedora Update System 2016-07-11 22:23:42 EDT
glibc-arm-linux-gnu-2.23-4.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.